   
{$D+,C-,R+,P+,T+,U10}

{A program to illustrate the format of real numbers.
Started 7/24/91.  Merlin L. Hanson}

PROGRAM ShowReal;
  {$I AUXSUBS.PAS}
  VAR
    nl : string[2];                     {new line}
    Printer : text;                     {used for debug, only}

PROCEDURE DoMain;
  TYPE     
    T723 = RECORD
             CASE {  } integer OF
               1 : (rl:real);
               2 : (mantissa:PACKED ARRAY [0..5] OF byte);  
               {Mantissa[5] is actually the scale factor.}
               3 : (a:integer;
                    b:integer;
                    c:integer);
           END{record};    

  VAR 
    x : real;             {Get user input via 'ReadLn(x)'}
    liar : T723;          {The entire program is centered on this variable!}
    ShiftCount : integer;
    Sign : string;
                 (*** Property of Pop and Push ***)
    arr : ARRAY[0..39]OF char;
    zix : integer;

  PROCEDURE GetNumber;
  
    {Generate a small number and put it in x as though the user had typed it.}
    PROCEDURE GenSmall;
      VAR n:integer;
      BEGIN
        liar.a := 0;
        liar.b := 0;
        liar.c := $0001;                  {exponent of 0 would indicate the _number_ is 0.}
        x := liar.rl;
        {The smallest positive number is converted to: 2.9387358771E-39.}
      END{gensmall};
     
    {Generate a big number and put it in x as though the user had entered it.} 
    PROCEDURE GenBig;
      BEGIN
        liar.a := $7FFF;                  {sign bit = 0}
        liar.b := $FFFF;
        liar.c := $FFFF;
        x := liar.rl;
        {The largest positive number is converted to:1.7014118346e+38.}
      END{genbig};
      
    {Generate the largest negative number.}
    PROCEDURE GenBigNeg;
      BEGIN
        liar.a := $FFFF;
        liar.b := $FFFF;
        liar.c := $FFFF;
        x := liar.rl;
        {The largest negative number is converted to: -1.7014118346e-38}
      END{genbigneg};
      
    {generate the smallest negative number.}
    PROCEDURE GenSmallNeg;
      BEGIN
        liar.a := $8000;                  {The 8 is the sign bit. The MSB is}
        liar.b := $0;                     {one by virute of being a  normalized}
        liar.c := $0001;                  {floating point number!}
        x := liar.rl;
        {The negative number closest to zero is: -2.9387358771E-39}
      END{gensmallneg};
    
    BEGIN{getnumber}
      GOTOXY(0,21);
      Write('    Enter a number:');
      ReadLn(x);
      GOTOXY(0,10);
      CLR_EOS;
      GOTOXY(0,10);
      liar.rl := x;   {may be overwritten}
      IF ABS(x) < 100
        THEN  
          CASE ROUND(x) OF 
            -98 : GenSmall;
            -97 : GenBig;
            -95 : GenBigNeg;
            -96 : GenSmallNeg;
            -99 : {         };
          END{case};        
      Write('  Pascal output:',x);
    END{getnumber};

  PROCEDURE ShowNumber;
    VAR i:integer;
  
    PROCEDURE Title(Nbr:integer);   
      BEGIN
        CASE nbr OF
          0 : Write(
'       Unedited hex:');
          1 : WriteLn(
'       Mantissa                       Exponent');                
          2 : WriteLn(
'       Mantissa, sign removed         Exponent, bias removed');                  
          3 : WriteLn(
'       Binary.  Exponent was used to shift the radix point');          
        END{case};  
      END{title};

    {Extract the mantissa bits and put them into an array of bits.
    But use the terminology of stacks.}      
    PROCEDURE ExtractMantissa;
    
      {The source is 'x'.  Push 'n' bits onto the array}
      PROCEDURE PushBits(x,n:integer);
        VAR bit:integer;
        {Only routine entitled to modify zix after it is initialized.}
        PROCEDURE Push(ch:char);    {------------}
          BEGIN
            Arr[zix] := ch;
            zix := zix + 1;
          END{push};
        BEGIN{pushbits}
          FOR bit := 1 TO  n DO
            BEGIN
              IF (x & $8000) <> 0
                THEN Push('1')
                ELSE Push('0');
              x := SHL(x,1);  
            END;
        END{doword};
        
    BEGIN{extractmantissa}
      PushBits(liar.a,16);   {Mantissa[0], [1]}
      PushBits(liar.b,16);   {        [2], [3]}
      PushBits(liar.c,8);    {        [4]     }
    END{extractmantissa};
    
    {Break out the sign bit, replace it in the mantissa with the actual value.}
    PROCEDURE ShowMantissa;
      VAR i:integer;
      BEGIN
        IF ((liar.mantissa[0] & $80 ) <> 0)
          THEN Sign := '    -'                             {Leave topmost bit set}
          ELSE 
            BEGIN
               Sign := '    +';
               liar.mantissa[0] := liar.mantissa[0] | $80; {Set topmost bit}  
            END;  
        Write(Sign);    
        FOR i := 0 TO 4 DO
          Write(liar.mantissa[i]:2:h);    
      END{showmantissa};
      
    PROCEDURE LeadingZeros(ShiftCount:integer);  
      BEGIN
        IF ShiftCount < 0
          THEN
            BEGIN
              Write('.');
              REPEAT
                Write('0');
                ShiftCount := ShiftCount + 1;
              UNTIL ShiftCount = 0;
            END;  
      END{leadingzeros};
      
    PROCEDURE ShowBinary;
      VAR i:integer;
      {Pop the bits out of the array and at the same time, 
      decrement the shift count.
      Print the radix point when appropriate.
      The only routine entitled to change zix after it is initialized.}
      FUNCTION Pop:char;     {------------}
        BEGIN
          IF (ShiftCount = 0) 
            THEN Write('.');
          ShiftCount := ShiftCount - 1;  
          Pop := Arr[zix];
          zix := zix + 1;
        END{pop};
      BEGIN{showbinary}
        LeadingZeros(ShiftCount);
        zix := 0;
        FOR i := 1 TO 40 DO
          Write(Pop);
        {trailing zeros}  
        IF ShiftCount > 0
          THEN
            BEGIN  
              FOR i := 1 TO ShiftCount DO
                Write('0');
              Write('.');
            END;    
      END{showbinary};
      
    BEGIN{shownumber}
      Title(0);
      Write(liar.a:4:h, liar.b:4:h, liar.c:4:h,  nl,  nl);    
      Title(1);
      Write('     ');
      FOR i := 0 TO 4 DO
        Write(liar.mantissa[i]:2:h);
      Write('                          ',  liar.mantissa[5]:2:h, '  ',  nl);
      Title(2);
      ShowMantissa;
      ShiftCount := liar.Mantissa[5] - $80;
      Write('                         Hex:',ShiftCount:2:h, '  Dec:',ShiftCount:3,  nl);
      Write(nl,  '    ');
      ExtractMantissa;
      Title(3);
      Write(Sign);
      ShowBinary;
    END{shownumber};
    
  BEGIN{domain}
    Write(nl, '      Some valid formats:  2  4.5  .3  -6.7  .0089  0.01    ',  nl);
    Write(    '                           1.2e13   9.8e-37     +12.1e+19 ',    nl);
    Write(    '      Forbidden  formats:  3.    e3'                      ,  nl, nl);
    Write(nl, 
'      -99:Exit   -98: Smallest positive   -97: Biggest positive',  nl);
    Write(    
'                 -96: Smallest negative   -95: Most negative',     nl, nl);
    GetNumber;
    WHILE x <> -99.0 DO
      BEGIN
        zix := 0;
        ShowNumber;
        GetNumber;
      END{while};
  END{domain};
  
BEGIN{program}
  REWRITE(Printer,'PRN:');
  nl := CONCAT(#13, #10);               {CR LF}
  CLRSCRN;
  CURS_ON;
  Write(#27,'v');                       {automatic overflow on}
  DoMain;
  CURS_OFF;
  Write(#27,'w');                       {automatic overflow off}
END{program}.
  

                    Program table of contents.  
                    Line numbers are approximate
    7 PROGRAM ShowReal;
    8  |{$I AUXSUBS.PAS}
   13 PROCEDURE DoMain;
   34  |PROCEDURE GetNumber;
   37  | |PROCEDURE GenSmall;
   48  | |PROCEDURE GenBig;
   58  | |PROCEDURE GenBigNeg;
   68  | |PROCEDURE GenSmallNeg;
   77  | |BEGIN{getnumber}
   97  |PROCEDURE ShowNumber;
  100  | |PROCEDURE Title(Nbr:integer);   
  116  | |PROCEDURE ExtractMantissa;
  119  | | |PROCEDURE PushBits(x,n:integer);
  122  | | | |PROCEDURE Push(ch:char);    {------------}
  127  | | | |BEGIN{pushbits}
  137  | |BEGIN{extractmantissa}
  144  | |PROCEDURE ShowMantissa;
  159  | |PROCEDURE LeadingZeros(ShiftCount:integer);  
  172  | |PROCEDURE ShowBinary;
  178  | | |FUNCTION Pop:char;     {------------}
  186  | | |BEGIN{showbinary}
  201  | |BEGIN{shownumber}
  220  |BEGIN{domain}
  237 BEGIN{program}

